<!DOCTYPE html>
<html
	xmlns:th="http://www.thymeleaf.org"
	xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{layouts/admin.html}"
>
	<head>
		<title layout:title-pattern="$CONTENT_TITLE - $LAYOUT_TITLE">
			Setting - Staff
		</title>
		<script src="https://code.jquery.com/jquery-3.5.0.min.js"></script>
		<script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>
		<script th:inline="javascript">
			$(document).ready(function () {
				// Function to format how users are displayed in the dropdown
				function formatUser(user) {
					if (user.loading) {
						return user.text;
					}

					const $container = $(
							`<div class="flex items-center gap-2">
					<img class="w-10 h-10 rounded-full" src="${user.img}" alt="${user.text}">
					<div class="font-medium dark:text-white">
						<div>${user.text}</div>
						<div class="text-sm text-gray-500 dark:text-gray-400">${user.email}</div>
					</div>
				</div>`
					);
					return $container;
				}

				// Function to format the selected option
				function formatUserSelection(user) {
					if (!user.id) {
						return user.text;
					}
					const photoUrl = user.photo ? user.photo : '/img/user.svg';

					const $container = $(
							`<div class="flex items-center gap-2">
								<img class="w-6 h-6 rounded-full" src="${photoUrl}" alt="${user.text}">
								<div class="font-medium dark:text-white">${user.text}</div>
							</div>`
					);
					return $container;
				}

				// Initialize Select2
				$("#employes").select2({
					placeholder: "-- Pilih Karyawan --",
					minimumInputLength: 0,
					ajax: {
						url: '/employee/lecturer',
						dataType: 'json',
						delay: 250,
						data: function (params) {
							return {
								search: params.term || '',
							};
						},
						processResults: function (data, params) {
							if (!data || !data.data || !data.data.content) {
								console.error('Invalid data format:', data);
								return { results: [], pagination: { more: false } };
							}

							return {
								results: data.data.content.map(function (employee) {
									return {
										id: employee.id,
										text: employee.fullName,
										email: employee.email,
										img: employee.photo || '/img/user.svg' // Default image, update if you have dynamic images
									};
								}),
								pagination: {
									more: (params.page * 10) < data.totalCount
								}
							};
						},
						cache: true
					},
					templateResult: formatUser,
					templateSelection: formatUserSelection
				});

				$("#employe").select2({
					placeholder: "-- Pilih Karyawan --",
					minimumInputLength: 0,
					ajax: {
						url: '/employee/lecture',
						dataType: 'json',
						delay: 250,
						data: function (params) {
							return {
								search: params.term || '',
								id: $('#employeeId').val()
							};
						},
						processResults: function (data, params) {
							if (!data || !data.data || !data.data.content) {
								console.error('Invalid data format:', data);
								return { results: [], pagination: { more: false } };
							}

							return {
								results: data.data.content.map(function (employee) {
									return {
										id: employee.id,
										text: employee.fullName,
										email: employee.email,
										img: employee.photo || '/img/user.svg' // Default image if no photo
									};
								}),
								pagination: {
									more: (params.page * 10) < data.totalCount
								}
							};
						},
						cache: true
					},
					templateResult: formatUser,
					templateSelection: formatUserSelection
				});

				function fetchAndSelectEmploye(employeeId) {
					if (!employeeId) {
						return;
					}

					$("#employe").val(null).trigger('change');

					$.ajax({
						url: `/employee/lecture`,
						dataType: 'json',
						data: {
							id: employeeId,
							search: ''
						},
						success: function(data) {
							if (!data || !data.data || !data.data.content) {
								console.error('Invalid data format:', data);
								return;
							}

							const selectedEmployee = data.data.content.find(employee => employee.id == employeeId);
							if (selectedEmployee) {
								// Append the selected employee to the correct Select2 element
								$("#employe").append(new Option(selectedEmployee.fullName, selectedEmployee.id, true, true)).trigger('change');
							} else {
								console.error('Employee with ID ' + employeeId + ' not found');
							}
						},
						error: function(xhr, status, error) {
							console.error('Error fetching employee:', error);
						}
					});
				}

				window.editLecture = function(id, prodi, jenis, employee) {
					// Set form field values
					$("#lectureId").val(id);
					$("#jenis").val(jenis);
					$("#employeeId").val(employee);
					$("#prodi").val(prodi).trigger('change');
					fetchAndSelectEmploye(employee);
				}

				window.redirectToEmployee = function() {
					window.location.href = '/lecturer';
				}

				// Function to redirect to trash page
				window.redirectToTrash = function() {
					window.location.href = '/lecturer?trash=true';
				}
			});
		</script>
	</head>
	<body layout:fragment="content">
		<!-- form -->
		<div th:replace="~{lecturer/partials/form.html :: form}"></div>
		<div th:replace="~{lecturer/partials/form-edit.html :: formEdit}"></div>
		<div class="container mx-auto px-4 mb-6 mt-6 space-y-6">
			<div
				class="relative overflow-hidden rounded-xl shadow bg-white dark:bg-gray-800"
			>
				<!-- table header -->
				<div
					th:replace="~{lecturer/partials/table-header.html :: tableHeader}"
				></div>
				<!-- table -->
				<div th:replace="~{lecturer/partials/table.html :: table}"></div>
				<!-- table footer -->
				<div
					th:replace="~{lecturer/partials/table-footer.html :: tableFooter}"
				></div>
			</div>
		</div>
	</body>
</html>
